﻿// log Spirals.as - interesting pattern using logarithmic spirals
//
// - Jim Bumgardner

SW = Stage.width;
SH = Stage.height;
RAD = Math.min(SW,SH);
degToRad = Math.PI/180;
var deg45 = Math.PI/8;

// Constants for controlling zoom of each spiral
var archK = 2;
var equiK = 2;
var fermatK = 1000;

// Rad func for this spiral
function equiangular(a)
{
	return Math.pow(equiK,a);
}

function rotator()
{
	this._rotation += this.rd;
}

MovieClip.prototype.drawFillSpiral = function(radFunc, fColor)
{
	var alphas = [100,0];
	var ratios = [0x0,0xFF];
	var matrix = { matrixType:"box", x:-RAD/2, y:-RAD/2, w:RAD, h:RAD, r: 0 }
	var colors = [fColor,fColor];

  	this.beginGradientFill("radial",colors,alphas,ratios,matrix);
	// this.beginFill(fColor, 100);
	var a = 0;
	var r = 0;
	this.moveTo(0,0);
	n = 0;
	while ( r < RAD) 
	{
		var ca = a+deg45/2;
		var cr = radFunc(ca)/Math.cos(deg45/2)
		a += deg45;
		r = radFunc(a);
		this.curveTo(Math.cos(ca)*cr,Math.sin(ca)*cr,
					 Math.cos(a)*r,Math.sin(a)*r);
		++n;
	}

	while (--n >= 0) 
	{
		var ca = a-deg45/2;
		var cr = radFunc(ca+Math.PI*2/3)/Math.cos(deg45/2)
		a -= deg45;
		r = radFunc(a+Math.PI*2/3);
		this.curveTo(Math.cos(ca)*cr,Math.sin(ca)*cr,
					 Math.cos(a)*r,Math.sin(a)*r);
	}
	this.lineTo(0,0);
	this.endFill();
}

for (i = 0; i < 16; ++i) {
	var mc = this.createEmptyMovieClip("mc_"+i, i);
	mc._x = SW/2;
	mc._y = SH/2;
	mc.drawFillSpiral(equiangular, random(0x1000000));
	mc.rd = Math.random()*12-6;
	mc._alpha = 50;
	mc._rotation = random(360);
	mc.onEnterFrame = rotator;
	if (random(2) == 0)
	{
		mc._xscale = -100;
	}
}

